from Marks import *
from Packet import *


class WireguardAnalyzer:

    def analyze(self, packet):
        # detekce wireguard dle bytu
        temp = -1
        length = -1

        if get_transport_protocol_from_packet(packet) == "UDP":
            if len(packet.raw_data) < 5:
                return 0
            temp = hex(packet.raw_data[0] + packet.raw_data[1] + packet.raw_data[2] + packet.raw_data[3])
            # handshake init
            if packet.payload_length == 148 and temp == '0x1':
                set_mark_on_packet(packet, Marks.WIREGUARD_CONTROL)
                return 1
            # handshake response
            if packet.payload_length == 92 and temp == '0x2':
                set_mark_on_packet(packet, Marks.WIREGUARD_CONTROL)
                return 1
            # cookie reply
            if packet.payload_length == 64 and temp == '0x3':
                set_mark_on_packet(packet, Marks.WIREGUARD_CONTROL)
                return 1
            # transport data + keepalive
            if packet.payload_length >= 32 and temp == '0x4':
                set_mark_on_packet(packet, Marks.WIREGUARD_DATA)
                return 1
        return 0

    def filter_false_positives(self, ip_addresses):
        intersect = set(ip_addresses[Marks.WIREGUARD_DATA].keys()).intersection(
            set(ip_addresses[Marks.WIREGUARD_CONTROL].keys()))
        for address in list(ip_addresses[Marks.WIREGUARD_DATA].keys()):
            if address not in intersect:
                del ip_addresses[Marks.WIREGUARD_DATA][address]

        for address in list(ip_addresses[Marks.WIREGUARD_CONTROL].keys()):
            if address not in intersect:
                del ip_addresses[Marks.WIREGUARD_CONTROL][address]
